
/***************************************************
* By CCSC compiler
*  File Name: 20191011_K463D_MK158B_1503.c
 * rev 1.0 20191011
*  Description: 
*  COPYRIGHT 2019 MYCOMKITS.COM, owned by CNET LIMITED
***************************************************/
//
#include <16f1503.h>
#DEVICE ADC=8
#fuses	INTRC_IO, NOWDT, NOMCLR, NOBROWNOUT, PUT, NOLVP, NOPROTECT,
#fuses	NOCLKOUT, NOWRT
#use	delay(CLOCK = 4000000)
#use	rs232(BAUD=9600, XMIT=PIN_A5)
//
#use	fast_io(a)
#use	fast_io(c)
//
#define Amode 0xDF			//port A all input except A5
#define Cmode 0xFC			//port C all input, except C0,1
#define MODE PIN_A4
#define BUSY PIN_C4 // active high
#define PIR PIN_C2 // active high
#define LDR PIN_C1 // active high
#define LED_GREEN PIN_C0 // active high
//
#byte OSCCON = 0x099
#byte WPUA = 0x20C
//#byte WPUC = 0x20E
#byte OPTION_REG = 0x095
#byte PCON = 0x096
// variables
int value;
int file_number;
int enable_flag = 0;
// prototyping
#separate
void get_sensor();
#separate
void initializing();
#separate
void mode_check();
#separate
void play_one();
#separate
void play_stop();
#separate
void get_number();
// main function
void main()
{
    initializing();
    //while(input(PIR) == 1) {} //detect motion
    delay_ms(60000);
    // main loop
    while(1)
    {
        mode_check();
        //
        if(input(PIR) == 1) //detect motion
        {
            
            if(enable_flag == 1)
            {
                if(input(BUSY) == 0)
                {
                    output_high(LED_GREEN);
                    get_number();
                    //specify file
                    putc(0x7E);
                    putc(0x04);
                    putc(0x42);
                    putc(0x01); //folder 001
                    putc(file_number);
                    putc(0xEF);
                    delay_ms(100);
                   play_one();
                   output_low(LED_GREEN);
                }
            }
        }
        
    }
}
//
#separate
void get_sensor()
{
    set_adc_channel(7);	//red, must wait 65u
    delay_us(100);
    value = read_adc();	//0 to 255
    if(value < 5) value = 0;	// 2 to 255
}
//
#separate
void initializing()
{
	set_tris_a(Amode);	//
	set_tris_c(Cmode);	//
	//
	setup_comparator(NC_NC_NC_NC);
	// A/D converter initialize
	setup_adc_ports(sAN7 | VSS_VDD);	// gnd to 5v
	setup_adc(ADC_CLOCK_DIV_8);			// 2usec
    //
    OPTION_REG = OPTION_REG & 0x7F;	// set 0 to WPUEN
    WPUA = 0x1F;	// pull up RA0 to 4
    output_low(LDR);
    output_low(LED_GREEN);
}
//
#separate
void mode_check()
{
    if(input(MODE) == 0)    // night
    {
        output_high(LDR);
        get_sensor();
        if(value < 0x7F) enable_flag = 1;
        else enable_flag = 0;
    }
    else
    {
        enable_flag = 1;
        output_low(LDR);
    }
}
//
#separate
void play_one()
 {
    putc(0x7E);
    putc(0x02);
    putc(0x01);
    putc(0xEF);
    delay_ms(1000);
    //
}
//
#separate
void play_stop()
{
    putc(0x7E);
    putc(0x02);
    putc(0x0E); // stop
    putc(0xEF);
    delay_ms(10);
}
//
#separate
void get_number()
{
    file_number = input_a() & 0x0F; // 0 to 15
    if(file_number == 0) file_number = 16;
}

